SystemOrganization addCategory: #OLE!

RectangleMorph subclass: #NumberGame
	instanceVariableNames: 'minValue maxSum minSum haveMadeMistake score total level difficulty lastAnswer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

NumberGame subclass: #MultiplyGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!NumberGame class methodsFor: 'game' stamp: 'lg 10/1/2007 16:29'!
answer: n 
	World allMorphsDo: [ :m | (m isKindOf: self) ifTrue: [m answer: n]].
! !

!NumberGame class methodsFor: 'game' stamp: 'lg 10/12/2007 12:50'!
beginGame
	World allMorphsDo: [ :m | (m isKindOf: NumberGame) ifTrue: [m beginGame] ].! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 14:42'!
answer: n
	lastAnswer := n.
	n = self getGameValue ifTrue: [self win: n] ifFalse: [self lose].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 12/24/2007 09:58'!
beginGame
	ActiveWorld cleanUpReferences.
	World allMorphsDo: [ :m | (m isKindOf: ObjectSetMorph) ifTrue: [m resetObjectSequence]].
	self setLevel: 1.
	self setScore: 0.
	World selectMorphs: #isGameChoice do: #show.
	self setTotal: -1. "XXX cheesy"
	self newGame.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 13:10'!
chooseObject
	World allMorphsDo: [ :m | (m isKindOf: ObjectSetMorph) ifTrue: [m installNewTallyMorph ]].! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 13:38'!
difficulty: d
	difficulty := d.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 14:34'!
displayAnswer: n
	[ World selectKind: AnswerViewMorph do: [ :m | m contents: n asString. m show. (Delay forSeconds: 2) wait ]] fork.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 12/5/2007 12:08'!
displayMood: mood
	"["GameFeedbackMorph showState: mood.
	 (mood = #happy) ifTrue: [World selectKind: AnswerViewMorph do: [:m | m contents: lastAnswer asString; show]].
	World doOneCycleNow.
	 (Delay forSeconds: 2) wait.
	 GameFeedbackMorph showState: #neutral.
	 World selectKind: AnswerViewMorph do: #hide
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 18:19'!
endGame
	self beep: 'byebye'.
	World selectMorphs: #isGameChoice do: #hide.
	World selectMorphs: #isGameInput do: [ :m | m setGameValue: 0 ].! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 15:33'!
gameChoices
	^World allMorphs select: #isGameChoice.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:30'!
gameInputs
	^World allMorphs select: #isGameInput.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^(self gameInputs collect: #getGameValue) sum.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/8/2007 17:06'!
increaseInputs
	| used seed |
	used := minValue * self gameInputs size.
	seed := ((minSum to: maxSum) - used) atRandom.
	seed timesRepeat: [ self gameInputs atRandom increment ].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/9/2007 09:07'!
initialize
	super initialize.
	self beginGame.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 14:45'!
lose
	self beep: 'wrong3'. self displayMood: #sad; mistake.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 14:03'!
mistake
	haveMadeMistake := true.
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 14:02'!
newGame
	haveMadeMistake := false.
	self setTotal: total + 1; resetInputs; increaseInputs; updateChoices.
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:15'!
resetInputs
	self gameInputs do: [ :input | input setGameValue: minValue ].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 12:55'!
score
	self setScore: score + 1.
	(score \\ 10) = 0 ifTrue: [self setLevel: 1 + (score / 10)].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 13:33'!
setLevel: n
	level := n.
	World selectMorphs: #isGameLevel do: [:morph | morph contents: level asString].
	self chooseObject.
	difficulty = #easy
		ifTrue:
		[n = 1 ifTrue: [minValue := 1. minSum :=2. maxSum := 4].
		 n = 2 ifTrue: [minValue := 1. minSum := 2. maxSum := 6].
		 n = 3 ifTrue: [minValue := 1. minSum := 2. maxSum := 8].
		 n = 4 ifTrue: [minValue := 0. minSum := 2. maxSum := 9].
		 n > 4 ifTrue: [self endGame] ]
		ifFalse:
		[n = 1 ifTrue: [minValue := 1. minSum := 2. maxSum := 6].
		 n = 2 ifTrue: [minValue := 0. minSum := 0. maxSum := 9].
		 n = 3 ifTrue: [minValue := 0. minSum := 9. maxSum := 15].
		 n = 4 ifTrue: [minValue := 0. minSum := 12. maxSum := 20].
		 n > 4 ifTrue: [self endGame] ].

! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 12:55'!
setScore: n
	score := n.
	World selectMorphs: #isGameScore do: [ :morph | morph setGameValue: score].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 13:52'!
setTotal: n
	total := n.
	World selectMorphs: #isGameTotal do: [ :morph | morph setGameValue: score].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/2/2007 15:33'!
updateChoices
	| choices correct answers results stream |
	choices := self gameChoices.
	correct := self getGameValue.
	answers := (minValue to: maxSum) asArray shuffled reject: [ :x | x == correct]. 
	stream := answers readStream.
	results := OrderedCollection new.
	(choices size - 1) timesRepeat: [ results add: stream next ].
	results add: correct.
	results := results shuffled.
	stream := results readStream.
	choices do: [ :choice | choice setGameValue: stream next ].! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 18:57'!
win: n
	((n < 22) or: [n = 77]) ifTrue: [self beep: n asString] ifFalse: [self beep: 'right1'].
	self displayAnswer: n.
	haveMadeMistake ifFalse: [self score].
	self displayMood: #happy.
	self newGame.
! !

NumberGame subclass: #QuestionNumberGame
	instanceVariableNames: 'questions question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!QuestionNumberGame class methodsFor: 'game' stamp: 'lg 10/14/2007 16:01'!
readQuestion
	World selectKind: self do: #readQuestion.! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 14:00'!
answer
	^question valueOfProperty: #answer.! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 08:19'!
beginGame
	questions := (World allMorphs detect: [ :m | m isKindOf: QuestionSetMorph ]) questions.
	super beginGame.
! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 14:04'!
getGameValue
	^self answer.! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 17:59'!
newGame
	total := total + 1.
	question ifNotNil: [question delete].
	questions atEnd ifTrue: [ ^self endGame ].
	question := questions next.
	World addMorph: question.
	question position: 75@125.
	question lock.
	haveMadeMistake := false.
	self setupChoicesForQuestion.! !

!QuestionNumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 16:04'!
readQuestion
	self beep: (question valueOfProperty: #questionSound).! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 10:32'!
setupChoicesForQuestion
	| choices answers rightAnswer |
	choices := self gameChoices shuffled readStream.
	choices atEnd ifTrue: [^self].
	rightAnswer := question valueOfProperty: #answer.
	answers := ((rightAnswer // 2 to: rightAnswer * 2) asOrderedCollection remove: rightAnswer; yourself) shuffled readStream.
	choices next setGameValue: rightAnswer.
	[choices atEnd] whileFalse: [ choices next setGameValue: answers next ].! !

TextMorph subclass: #AnswerViewMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

TextMorph subclass: #GameLevel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameLevel methodsFor: 'as yet unclassified' stamp: 'lg 10/8/2007 17:10'!
isGameLevel
	^true! !

TextMorph subclass: #GameTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^self getNumericValue.! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
increment
	self setNumericValue: self getNumericValue + 1.! !

!GameTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:25'!
isGameInput
	^true! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
setGameValue: n 
	self setNumericValue: n.! !

GameTextMorph subclass: #ScoreTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

ScoreTextMorph subclass: #MistakesTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MistakesTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/3/2007 12:47'!
isGameMistakes
	^true! !

!MistakesTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/3/2007 12:47'!
isGameScore
	^false! !

!ScoreTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 16:37'!
isGameInput
	^false! !

!ScoreTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 16:52'!
isGameScore
	^true! !

!TextMorph methodsFor: '*ole-game' stamp: 'lg 10/29/2007 15:36'!
gameValue
	^self getCharacters asNumber.! !

!TextMorph methodsFor: '*ole-game' stamp: 'lg 10/29/2007 15:33'!
gameValue: value
	self contents: value asString.! !

!SequenceableCollection methodsFor: '*ole-removing' stamp: 'lg 11/1/2007 08:38'!
without: element
	^self select: [ :o | o ~= element ].! !

!Project class methodsFor: '*ole' stamp: 'lg 12/7/2007 10:52'!
fromUnderImage: projectName
	| filename |
	filename :=ProjectLoading findProjectFileNamed: projectName recursivelyInDirectory: Smalltalk imagePath.
	^filename ifNotNil: [Project fromUrl: (FileUrl absoluteFromText: filename) asString].
! !

!Project class methodsFor: '*ole' stamp: 'lg 12/20/2007 22:43'!
iconFor: projectName inDirectory: dirName
	| dir icon |
	dir := FileDirectory on: dirName.
	icon := SketchMorph fromFile: (dir fullNameFor: projectName, '.gif').
	icon on: #click send: #openFromDirectory:andProjectName: to: ProjectLoading args: {dirName. projectName}.
	icon on: #mouseEnter send: #mouseOverHighlight to: icon.
	icon on: #mouseLeave send: #mouseOverUnhighlight to: icon.
	^icon
! !

!Project class methodsFor: '*ole' stamp: 'lg 12/20/2007 12:10'!
linksForDirectory: dirName
	| projects morph |
	projects := Project projectsInDirectory: dirName.
	projects isEmpty ifTrue: [^nil].
	morph := AlignmentMorph new layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		wrapCentering: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		cellInset: 10;
		color: Color transparent.
	projects do: [ :p | morph addMorphBack: (Project iconFor: p inDirectory: dirName)].
	^morph
! !

!Project class methodsFor: '*ole' stamp: 'lg 11/25/2007 11:26'!
namedUnderImage: projectName
	| filename |
	filename :=ProjectLoading findProjectFileNamed: projectName recursivelyInDirectory: Smalltalk imagePath.
	^filename ifNotNil: [Project namedUrl: (FileUrl absoluteFromText: filename)].
! !

!Project class methodsFor: '*ole' stamp: 'lg 12/17/2007 16:01'!
projectsInDirectory: dirName
	| projects parse |
	projects := Set new.
	(FileDirectory on: dirName) fileNames do:
		[ :fn | parse := Project parseProjectFileName: fn.
			(parse at: 3) = 'pr' ifTrue: [projects add: (parse at: 1)]].
	^projects asArray sort.! !

!Project methodsFor: '*ole' stamp: 'lg 10/13/2007 09:05'!
exit
	"Leave the current project and return to the project in which this one was created."

	self isTopProject ifTrue: [^ self beep: 'click' ].
	parentProject enter: false revert: false saveForRevert: false.
! !

!Project methodsFor: '*ole-file in/out' stamp: 'lg 11/24/2007 18:55'!
objectForDataStream: refStrm
	| uu dp |
	"I am about to be written on an object file.  Write a path to me in the other system instead."

	"Use a copy with no parent, previous or next to reduce extra stuff copied"
	refStrm project == self ifTrue: [^ self copy setParent: nil].

	dp _ (uu _ self url) size > 0 ifTrue: [
		(uu asString beginsWith: Smalltalk imagePath asUrl asString) ifTrue: [
			"OLE extension for flexibility: if the project was loaded from a path under the image directory, just remember the project name and then reload it by searching recursively for a project of that name. -luke"
			DiskProxy global: #Project selector: #namedUnderImage: args: {self name}
		] ifFalse: [
			DiskProxy global: #Project selector: #namedUrl: args: {uu}.
		]
	] ifFalse: [
		DiskProxy global: #Project selector: #named: args: {self name}
	].
	refStrm replace: self with: dp.
	^ dp
! !

!Project methodsFor: '*ole-disk i/o' stamp: 'lg 12/7/2007 11:07'!
setupDiskProxyUnderImage
	^DiskProxy new setupForProjectUnderImage: self name! !

Object subclass: #AnimalKingdom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Object subclass: #OLE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

OLE class
	instanceVariableNames: 'halosEnabled authorMode'!

OLE class
	instanceVariableNames: 'halosEnabled authorMode'!

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/20/2007 23:15'!
authorMode
	Preferences
		disable: #eToyFriendly;
		enable: #warnIfNoSourcesFile;
		enable: #warnIfNoChangesFile;
		disable: #oleDeploymentMode;
		disable: #noHalos.
	self updateSugarToolbar.! !

!OLE class methodsFor: 'sound effects' stamp: 'lg 9/29/2007 13:02'!
congratulate
	"Not implemented" nil.! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/18/2007 12:29'!
deploy
	self userMode.
	Preferences
		disable: #warnIfNoSourcesFile;
		disable: #warnIfNoChangesFile;
		enable: #oleDeploymentMode.! !

!OLE class methodsFor: '*ole-project' stamp: 'lg 12/19/2007 14:45'!
ensureImagesAreLoaded
	| dir |
	Images isEmpty ifFalse: [^self].
	dir := Smalltalk imagePath, FileDirectory slash, 'assets', FileDirectory slash, 'currency_notes', FileDirectory slash.
	#(1 2 5 10 25 50 100 500 1000) do: [ :n |
		Images addMorphBack: (SketchMorph fromFile: dir , n asString , '_front.jpg').
		Images addMorphBack: (SketchMorph fromFile: dir , n asString , '_back.jpg').
		Images addMorphBack: (SketchMorph fromFile: dir , 'animal_', n asString , '.jpg')].
! !

!OLE class methodsFor: '*ole-project' stamp: 'lg 12/19/2007 14:19'!
initializeAnimalsOnMoney
	| dir numbers choices answer |
	dir := Smalltalk imagePath, FileDirectory slash, 'assets', FileDirectory slash, 'currency_notes', FileDirectory slash.
	choices := #(1 2 5 10 25 50 100 500 1000 ) shuffled first: 3.
	answer := choices atRandom.
	Hint setGraphic: (self animalGraphic: answer).
	{Choice1. Choice2. Choice3} with: choices do:
		[:choice :note |
			choice
				setFront: (self frontGraphic: note);
				setBack: (self backGraphic: note);
				setCorrect: note == answer.
			choice showFront]! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/18/2007 12:19'!
isAuthorMode
	^Preferences eToyFriendly not.
! !

!OLE class methodsFor: 'image' stamp: 'lg 10/14/2007 09:49'!
saveSoon
	[(Delay forSeconds: 10) wait. SmalltalkImage current saveSession] fork.! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/20/2007 23:16'!
updateSugarToolbar
	World allMorphsDo: [ :m | (m isKindOf: SugarNavigatorBar) ifTrue: [m removeAllMorphs; addButtons]]! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/20/2007 23:16'!
userMode
	Preferences
		enable: #eToyFriendly;
		enable: #noHalos.
	self updateSugarToolbar.! !

!OLE class methodsFor: 'class initialization' stamp: 'lg 12/18/2007 12:26'!
initialize
	Preferences addBooleanPreference: #oleDeploymentMode categories: #('OLE' 'OLPC') default: false balloonHelp: 'Enable behaviour that is appropriate in images running the OLE Nepal E-Paati activities but not in development images, for example automatic removal of projects after use.'
! !

Thumbnail subclass: #PicturePuzzleThumbnailMorph
	instanceVariableNames: 'puzzlePictureForm gridSize labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

PicturePuzzleThumbnailMorph subclass: #PicturePuzzleFileThumbnailMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleThumbnailMorph methodsFor: 'event handling' stamp: 'lg 10/10/2007 14:55'!
handlesMouseDown: event
	^true! !

!PicturePuzzleThumbnailMorph methodsFor: 'initialization' stamp: 'lg 10/13/2007 09:24'!
initialize
	super initialize.
	self maxWidth: 200 minHeight: 150.
	gridSize := 4.! !

!PicturePuzzleThumbnailMorph methodsFor: 'puzzle' stamp: 'lg 10/13/2007 13:09'!
labels: type
	labels := type.! !

!PicturePuzzleThumbnailMorph methodsFor: 'puzzle' stamp: 'lg 10/10/2007 10:38'!
makeThumbnailFromForm: form
	puzzlePictureForm := form.
	^super makeThumbnailFromForm: form.! !

!PicturePuzzleThumbnailMorph methodsFor: 'event handling' stamp: 'lg 10/10/2007 14:55'!
mouseDown: event
	self openPuzzle.! !

!PicturePuzzleThumbnailMorph methodsFor: 'puzzle' stamp: 'lg 10/14/2007 18:34'!
openPuzzle
	| morph |
	World allMorphsDo: [ :m | (m isKindOf: PicturePuzzleMorph) ifTrue: [m delete] ].
	morph := PicturePuzzleMorph new showSketch: (SketchMorph withForm: puzzlePictureForm).
	morph center: World center.
	morph top: 90.
	morph rows: gridSize; columns: gridSize.
	morph labels: (labels caseOf: { [nil] -> [ #() ].
							      [#letters] -> ['ABCDEFGHIJKLMNOPQRSTUVWXYZ' asArray collect: #asString].
							      [#numbers] -> [(1 to: 100) collect: #asString]}).
	morph rescramble.
	morph openInWorld.! !

!DiskProxy methodsFor: '*ole' stamp: 'lg 12/7/2007 10:53'!
enter: returningFlag revert: revertFlag saveForRevert: saveForRevert
	"Look for our project on the server, then try to enter it!!  DiskProxy is acting as a stub for the real thing.  Called from a ProjectViewMorph in the current project.  If have url, use it.  Else look in current Project's server and folder."

	constructorSelector == #namedExample: ifTrue: ["Project namedUrl: xxx"
		^ ((Smalltalk at: globalObjectName) perform: #fromExampleEtoys:
					withArguments: constructorArgs) ].
	constructorSelector == #namedUrl: ifTrue: ["Project namedUrl: xxx"
		^ ((Smalltalk at: globalObjectName) perform: #fromUrl:
					withArguments: constructorArgs) ].
	constructorSelector == #named: ifTrue: [
		CurrentProjectRefactoring currentFromMyServerLoad: constructorArgs first].	"name"
	constructorSelector == #namedUnderImage: ifTrue: [
		^ ((Smalltalk at: globalObjectName) perform: #fromUnderImage: withArguments: constructorArgs)].
! !

!DiskProxy methodsFor: '*ole' stamp: 'lg 12/7/2007 11:01'!
setupForProjectUnderImage: projectName
	globalObjectName := #Project.
	constructorSelector := #namedUnderImage:.
	constructorArgs := { projectName }.
! !

Morph subclass: #GameFeedbackMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameFeedbackMorph class methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 18:00'!
showState: state
	| class |
	class := state caseOf: { [#happy]   -> [GameHappyMorph].
						 [#neutral] -> [GameNeutralMorph].
						 [#sad]       -> [GameSadMorph] }.
	World selectKind: self do: [ :m | (m isKindOf: class) ifTrue: [m show] ifFalse: [m hide] ].
! !

GameFeedbackMorph subclass: #GameHappyMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

GameFeedbackMorph subclass: #GameNeutralMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

GameFeedbackMorph subclass: #GameSadMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Morph subclass: #HighlighterMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Morph subclass: #HighlightMorph
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:19'!
handlesMouseDown: event
	^true! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:23'!
handlesMouseOver: event
	^true! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 11:04'!
mouseDown: event
	self color: Color transparent.
	self beep: 'click'.
	project enter! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:25'!
mouseEnter: event
	self color: (Color yellow alpha: 0.3).! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:25'!
mouseLeave: event
	self color: Color transparent.! !

!Morph class methodsFor: '*ole-scripting' stamp: 'lg 10/30/2007 17:27'!
additionsToViewerCategoryAsObject
	"Answer viewer additions for the 'as object' category.  Just priming the pump at this point."

	^#(
		#'as object' 
		(
			(slot size 'My physical size' Number readOnly Player getObjectSize unused unused)
			(slot name  	'The name by which I am known' String readWrite Player 	getName Player setName:)
			(slot hash 'My hash value' Number readOnly Player getHash unused unused)
			(command explore 'Open up an Explorer on this object')
			(command halt: 'Put up a pre-debug notifier' String)
			(slot printString 'A string rendition of myself' String readOnly  Player getPrintString unused unused)
			(command inform: 'Put up message box for the user' String)
			(command printInTranscript 'Prints a description of the object to the Transcript')
			(command printDirectlyToDisplay 'Prints a description of the object directly to the screen')
			(command waitForSeconds: 'Wait for a period of seconds (Squeak will not execute other scripts during this time)' Number)
			(slot className 'The name of the class of the object' String readOnly player getClassName unused unused)

		))
! !

!Morph class methodsFor: '*ole-scripting' stamp: 'lg 11/1/2007 10:36'!
additionsToViewerCategoryGameInstrument
	(World allMorphs select: [ :m | m isKindOf: AddingGameMorph]) ifEmpty: [^ #() ].
	^#( #'game instrument'
			( (slot gameInstrumentType 'The type of game instrument.' GameInstrumentType readWrite Player getGameInstrumentType Player setGameInstrumentType:)
"			  (slot gameValue 'The numeric value' Number readWrite Player getGameValue Player setGameValue:)" )
		)! !

!Morph class methodsFor: '*ole-scripting' stamp: 'lg 10/29/2007 14:46'!
supportsGameValue
	^false! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/30/2007 12:44'!
addGameItemsTo: aMenu hand: aHandMorph
"	aMenu add: 'OLE game...' translated subMenu:  (self buildGameMenu: aHandMorph)"! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/29/2007 17:49'!
beGameChoiceString
	^ (self gameInstrumentType = #choice) yesNoString , 'be game choice'.! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/29/2007 17:49'!
beGameInputString
	^ (self gameInstrumentType = #input) yesNoString , 'be game input'.! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/29/2007 17:49'!
buildGameMenu: aHand
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	self hasGameValue ifTrue:
		[aMenu addUpdating: #beGameInputString target: self selector: #toggleGameInstrumentType: argumentList: { #gameInput }.
		 aMenu addUpdating: #beGameChoiceString target: self selector: #toggleGameInstrumentType: argumentList: { #gameChoice } ].
	^ aMenu! !

!Morph methodsFor: '*ole' stamp: 'lg 9/25/2007 10:20'!
exchangeWith: morph 
	morph position: self position; extent: self extent.
	owner replaceSubmorph: self by: morph.! !

!Morph methodsFor: '*ole-bugfix' stamp: 'lg 10/2/2007 15:44'!
fixYourLayout
	| realExtent |
	realExtent := self extent.
	self extent: 10@10.
	self extent: realExtent.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
gameChoices
	^self gameInstrumentsOfType: #choice.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
gameInputs
	^self gameInstrumentsOfType: #input.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 11/26/2007 11:58'!
gameInstrumentsOfType: type
	| morphs |
	morphs := self allMorphs select: [ :m | (m valueOfProperty: #gameInstrumentType) = type ].
	^morphs asArray sort: [ :a :b | (a x + a y) < (b x + b y) ].! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:38'!
gameInstrumentType
	^(self valueOfProperty: #gameInstrumentType) ifNil: [#none].! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:38'!
gameInstrumentType: type
	self setProperty: #gameInstrumentType toValue: type.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/10/2007 10:33'!
grab
	self center: World activeHand center.
	World activeHand grabMorph: self.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 11:36'!
hasGameValue
	^false.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/13/2007 10:06'!
highlightOnMouseOver
	| morph |
	morph := SimpleHighlightMorph new beSticky; extent: self extent; position: self position.
	self addMorph:morph.! !

!Morph methodsFor: '*ole-event handling' stamp: 'lg 12/17/2007 18:40'!
invocation: spec event: ignored1 morph: ignored2
	(spec at: 1) perform: (spec at: 2) withArguments: (spec at: 3).! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/2/2007 15:10'!
isGameChoice
	^false! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:38'!
isGameInput
	^self gameInstrumentType = #gameInput.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/8/2007 17:10'!
isGameLevel
	^false! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/3/2007 12:46'!
isGameMistakes
	^false! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/2/2007 16:51'!
isGameScore
	^false! !

!Morph methodsFor: '*ole' stamp: 'lg 10/13/2007 14:03'!
isGameTotal
	^false! !

!Morph methodsFor: '*ole-event handling' stamp: 'lg 12/17/2007 18:37'!
morph: ignored1 event: ignored2 invocation: spec.
	(spec at: 1) perform: (spec at: 2) withArguments: (spec at: 3).! !

!Morph methodsFor: '*ole-highlight' stamp: 'lg 12/20/2007 22:27'!
mouseOverHighlight
	| highlight |
	highlight := Morph new color: (Color yellow alpha: 0.25).
	highlight lock; extent: self extent; position: self position.
	self addMorph: highlight.
! !

!Morph methodsFor: '*ole-highlight' stamp: 'lg 12/20/2007 22:29'!
mouseOverUnhighlight
	self removeAllMorphs.! !

!Morph methodsFor: '*ole-event handling' stamp: 'lg 12/17/2007 18:43'!
on: event send: selector to: object args: args
	self on: event send: #invocation:event:morph: to: self withValue: {object. selector. args}
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/24/2007 17:00'!
ripOff
	| m |
	m := RipoffPatchMorph new initialize setTarget: self.
	owner addMorph: m after: self.
	owner removeMorph: self.
	self position: World activeHand position.
	World activeHand grabMorph: self.
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/29/2007 13:03'!
ripoff
   | morph patch |
	morph := RippedOffMorph new setTarget: self.
	patch := RipoffPatchMorph new setTarget: morph.
	morph setPatch: patch.
	self exchangeWith: patch.
	morph center: World activeHand center.
	World activeHand grabMorph: morph.
! !

!Morph methodsFor: '*ole' stamp: 'lg 10/12/2007 17:46'!
selectKind: class do: aBlock 
	self allMorphsDo: [ :morph | (morph isKindOf: class) ifTrue: [aBlock value: morph]].! !

!Morph methodsFor: '*ole' stamp: 'lg 10/3/2007 12:45'!
selectMorphs: test do: aBlock 
	self allMorphsDo: [ :morph | (test value: morph) ifTrue: [aBlock value: morph]].! !

!Morph methodsFor: '*OLE' stamp: 'ss 10/5/2007 13:41'!
showAnimal
           World addMorph: self.
           self position: 200@200! !

!Morph methodsFor: '*ole' stamp: 'lg 10/11/2007 13:06'!
spreadMorphs
	| morph stream blockWidth blockHeight spareWidth spareHeight objectWidth objectHeight columns rows |
	self submorphs isEmpty ifTrue: [^self].
	columns := self submorphs size sqrt roundedUp.
	rows := (self submorphs size / columns) roundedUp.
	blockWidth := self width / columns.
	blockHeight := self height / rows.
	objectWidth := self submorphs first width.
	objectHeight := self submorphs first height.
	spareWidth := blockWidth - objectWidth max: 0.
	spareHeight := blockHeight - objectHeight max: 0.
	stream := self submorphs readStream.
	(0 to: rows-1) do: [:row | (0 to: columns-1) do: [:col |
		morph := stream next.
		morph ifNotNil: [morph position: self position + ((col * blockWidth + (0 to: spareWidth) atRandom) @ (row * blockHeight + (0 to: spareHeight) atRandom))]
	]]! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 14:52'!
supportsGameValue
	^self class supportsGameValue.! !

!Morph methodsFor: '*ole' stamp: 'lg 11/26/2007 16:36'!
takeMorphs: morphs mirroringSubmorphsOf: x
	| sourcePositions relativePositions destinationPositions morph source dest |
	sourcePositions := morphs collect: #position.
	relativePositions := x submorphs collect: [ :m | m position - m owner position ].
	destinationPositions := relativePositions collect: [ :point | point + self position ].
	morphs do: [ :m | World addMorph: m ].
"	self break."
	(0 to: 1 by: 0.01) do: [ :amount | (1 to: morphs size) do: [ :ix |
		morph := morphs at: ix.
		source := sourcePositions at: ix.
		dest := destinationPositions at: ix.
		morph position: (source interpolateTo: dest at: amount).
		World displayWorldSafely.
	]].
	morphs do: [ :m | self addMorph: m ].
! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
toggleGameInstrumentType: type
	| newType |
	newType := self gameInstrumentType = type ifTrue: [nil] ifFalse: [type].
	self gameInstrumentType: newType.! !

!Morph methodsFor: '*ole' stamp: 'lg 12/14/2007 14:33'!
waitForSeconds: n 
	World displayWorldSafely.
	(Delay forSeconds: n) wait.! !

!Morph methodsFor: '*ole-override' stamp: 'lg 12/18/2007 12:42'!
wantsHaloFromClick

	^ self valueOfProperty: #wantsHaloFromClick ifAbsent: [^Preferences noHalos not].! !

Morph subclass: #PicturePuzzleMorph
	instanceVariableNames: 'labels rows columns realImageForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:30'!
checkCompletion
	(submorphs allSatisfy: #hasRightPiece) ifTrue: [self completed].! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 17:16'!
columns: c
	columns := c.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:27'!
completed
	self showSketch.! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/13/2007 13:02'!
initialize
	super initialize.
	rows := 6.
	columns := 6.
	labels := #().
	self beSticky.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/13/2007 13:02'!
labels: collection
	labels := collection.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/10/2007 10:21'!
placeInEmptyBox: morph
	| empty |
	empty := submorphs detect: [ :m | (m isKindOf: PicturePuzzleBlockMorph) and: [m submorphs isEmpty] ].
	empty addMorph: morph.
! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 17:17'!
rescramble
	self scrambleForm: realImageForm.! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 17:38'!
rows: r
	rows := r.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/14/2007 19:02'!
scrambleForm: form
	| letters tileWidth tileHeight morph sketch interior |
	self removeAllMorphs.
	letters := labels readStream.
	realImageForm := form.
	self extent: form extent.
	tileWidth := form width / columns.
	tileHeight := form height / rows.
 	(0 to: rows-1) do: [ :row | (0 to: columns-1) do: [ :col |
		morph := PicturePuzzleBlockMorph new.
		interior := (((row ~= 0) and: [row ~= (rows-1)]) and: [(col ~= 0) and: [col ~= (columns-1)]]).
		morph isInteriorBlock:interior.
		morph position: self position + ((col * tileWidth) @ (row * tileHeight)).
		morph extent: tileWidth @ tileHeight.
		morph layoutPolicy: TableLayout new.
		morph enableDrop: true.
		morph enableDrag: true.
		morph setProperty: #puzzlePosition toValue: row@col.
		self addMorph: morph.
		sketch := PicturePuzzlePieceMorph withForm: (form copy: (((col*tileWidth) @ (row*tileHeight)) extent: tileWidth@tileHeight)).
		sketch position: morph position.
		sketch setProperty: #puzzlePosition toValue: row@col.
		morph addMorph: sketch.
"		interior ifFalse: [sketch beSticky]."
		"Maybe label the morph"
		letters atEnd ifFalse: [sketch label: letters next].
	]].
	self shufflePieces.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:28'!
showSketch
	self showSketch: (SketchMorph withForm: realImageForm).
! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:32'!
showSketch: sketch
	realImageForm := sketch form.
	sketch position: self position.
	self extent: sketch extent.
	self removeAllMorphs; addMorph: sketch.
! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:25'!
shufflePieces
	| blocks pieces stream |
	blocks := self submorphs select: #isInteriorBlock.
	pieces := blocks collect: [ :block | block submorphs first ].
	stream := pieces shuffled readStream.
	blocks do: [ :block | block removeAllMorphs; addMorph: stream next ].
! !

Morph subclass: #RipoffPatch
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatch methodsFor: '*ole' stamp: 'lg 9/24/2007 17:54'!
setTarget: morph
	target := morph.
	self position: morph position; extent: morph extent.! !

Morph subclass: #RipoffPatchMorph
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/29/2007 13:03'!
initialize
	super initialize.
	self fillStyle: Color orange.
	self beSticky.
	self layoutPolicy: TableLayout new.
	self cellPositioning: #center; wrapCentering: #center; listCentering: #center.
	"XXX Add a text morph of a question mark"
	self cornerStyle: #rounded.
	! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:19'!
setTarget: ripoffMorph 
	target := ripoffMorph.! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:20'!
wantsDroppedMorph: morph event: evt
	^morph == target.

! !

Morph subclass: #SimpleHighlightMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 09:40'!
handlesMouseOver: event
	^true! !

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 10:07'!
initialize
	super initialize.
	self color: Color transparent.! !

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 10:08'!
mouseEnter: event
	^self color: (Color yellow alpha: 0.25).! !

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 09:41'!
mouseLeave: event
	^self color: Color transparent.! !

!SampledSound class methodsFor: '*ole' stamp: 'lg 10/13/2007 21:02'!
addLibrarySoundsFromWaveDirectory: directory
	| files snd |
	files := (FileDirectory on: directory) fileNamesMatching: '*.wav'.
	files do: [ :file |
		snd := SampledSound fromWaveFileNamed: directory, '/', file.
		SampledSound addLibrarySoundNamed: (file copyUpTo: $.) samples: snd samples samplingRate: snd originalSamplingRate ].! !

!Player methodsFor: '*ole' stamp: 'lg 11/11/2007 08:25'!
getDifficultyLevel
	^costume difficultyLevel! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 17:44'!
getGameInstrumentType
	^costume gameInstrumentType.! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 15:32'!
getGameValue
	^costume gameValue! !

!Player methodsFor: '*ole' stamp: 'lg 11/26/2007 12:37'!
getRightAnswer
	^costume getRightAnswer.! !

!Player methodsFor: '*ole' stamp: 'lg 11/11/2007 08:24'!
getTallyObject
	^costume tallyObject! !

!Player methodsFor: '*ole' stamp: 'lg 10/30/2007 17:46'!
sayNumber: n 
	self beep: n asString! !

!Player methodsFor: '*ole' stamp: 'lg 11/11/2007 08:25'!
setDifficultyLevel: n
	^costume difficultyLevel: n! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 17:44'!
setGameInstrumentType: type
	costume gameInstrumentType: type.! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 15:32'!
setGameValue: value
	costume gameValue: value! !

!Player methodsFor: '*ole' stamp: 'lg 11/11/2007 08:23'!
setTallyObject: morph
	^costume tallyObject: morph.! !

!Player methodsFor: '*ole' stamp: 'lg 11/1/2007 10:33'!
setupNewQuestion
	costume setupNewProblem! !

!Player methodsFor: '*ole' stamp: 'lg 10/30/2007 17:28'!
waitForSeconds: n 
	costume waitForSeconds: n.! !

StringMorph subclass: #AddingGameMorph
	instanceVariableNames: 'difficultyLevel tallyObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!AddingGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/26/2007 12:20'!
additionsToViewerCategoryAddingGame
	^#( #'adding game' (
			(slot tallyObject 'The object to appear in tally boxes' Player readWrite Player getTallyObject Player setTallyObject:)
			(slot difficultyLevel 'How hard to make the adding problems (higher is harder)' Number readWrite Player getDifficultyLevel Player setDifficultyLevel:)
			(slot rightAnswer 'The correct answer to the number problem' Number readOnly Player getRightAnswer unused unused)
			(command setupNewQuestion 'Put a new problem on the screen')
		))! !

!AddingGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 09:29'!
authoringPrototype
	^super authoringPrototype contents: '+'; fontName: 'BitstreamVeraSansMono' size: 100.! !

!AddingGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 11:50'!
descriptionForPartsBin
	^ self partName: 'AddingGame' categories: {'OLE'} documentation: 'Adding game quiz generator'! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 11:52'!
answerForInputs: inputs
	| numbers |
	numbers := inputs collect: #gameValue.
	^self rules caseOf: { [#+] -> [numbers sum].  [#-] -> [numbers first - numbers second] }.
! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/11/2007 08:21'!
difficultyLevel
	^difficultyLevel! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/11/2007 08:21'!
difficultyLevel: level
	difficultyLevel := level! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 12:27'!
getRightAnswer
	^self answerForInputs: World gameInputs.! !

!AddingGameMorph methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 09:47'!
initializeToStandAlone
	super initializeToStandAlone.
	self contents: '+'; fontName: 'BitstreamVeraSans' size: 100.! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 12:50'!
rules
	self contents = '+' ifTrue: [^#+].
	self contents = '-' ifTrue: [^#-].
	^nil.! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 12:16'!
setupInputs: inputs
	| answer left right |
	self rules caseOf:
	{ [#+] -> [
		answer := (2 to: 9) atRandom.
		left := (1 to: answer - 1) atRandom.
		right := answer - left. ].
	   [#-] -> [
		answer := (1 to: 8) atRandom.
		left := (answer + 1 to: 9) atRandom.
		right := left - answer. ]
	}.
	inputs first setGameValue: left tallyObject: tallyObject.
	inputs second setGameValue: right tallyObject: tallyObject.
! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 12:51'!
setupNewProblem
	| choices inputs answer choiceValues |
	self rules ifNil: [^self inform: 'Operator is not valid: ' , self contents].
	inputs := World gameInputs.
	choices := World gameChoices.
	inputs ifEmpty: [^self inform: 'You have to specify some inputs first'].
	choices ifEmpty: [^self inform: 'You have to specify some choices first'].
	self setupInputs: inputs.
"	inputs do: [ :choice | choice setGameValue: (1 to: 4) atRandom tallyObject: tallyObject]."
	answer := self answerForInputs: inputs.
"	answer := (inputs collect: #gameValue) sum."
	choiceValues := ( {answer} , ((2 to: 8) asArray shuffled without: answer) ) readStream.
	choices shuffled do: [ :input | input setGameValue: choiceValues next tallyObject: tallyObject].! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/11/2007 08:10'!
tallyObject
	^tallyObject! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/11/2007 08:10'!
tallyObject: morph
	tallyObject := morph.! !

AddingGameMorph subclass: #MinusGameMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MinusGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/24/2007 13:42'!
authoringPrototype
	^super authoringPrototype contents: '-'; fontName: 'BitstreamVeraSansMono' size: 100.! !

!MinusGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/24/2007 13:37'!
descriptionForPartsBin
	^ self partName: 'SubtractingGame' categories: {'OLE'} documentation: 'Subtracting game quiz generator'! !

!MinusGameMorph methodsFor: 'as yet unclassified' stamp: 'lg 11/24/2007 13:38'!
initializeToStandAlone
	super initializeToStandAlone contents: '-'.! !

!True methodsFor: '*ole' stamp: 'lg 10/29/2007 12:36'!
yesNoString
	^'<yes>'! !

!FileDirectory methodsFor: '*ole' stamp: 'lg 10/13/2007 20:18'!
importWaveSounds
	self shouldBeImplemented! !

PasteUpMorph subclass: #ObjectSetMorph
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ObjectSetMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 15:33'!
initialize
	super initialize.
	self resetObjectSequence.! !

!ObjectSetMorph methodsFor: 'objects' stamp: 'lg 10/11/2007 15:32'!
installNewTallyMorph
	| object |
	objects atEnd ifTrue: [^self].
	object := objects next.
	World allMorphsDo: [ :m | (m isKindOf: TallyMorph) ifTrue: [m setTallyObject: object] ].! !

!ObjectSetMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 15:31'!
resetObjectSequence
	objects := self submorphs readStream.! !

!PasteUpMorph class methodsFor: '*ole-scripting' stamp: 'lg 10/31/2007 16:07'!
additionsToViewerCategoryGameInstrument
	^ #().
! !

!PasteUpMorph methodsFor: '*OLE' stamp: 'ss 10/5/2007 13:52'!
animalNames
	^self  submorphs collect:
	[:morph| morph externalName]! !

!PasteUpMorph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 15:55'!
gameValue
	^self submorphs size! !

!PasteUpMorph methodsFor: '*ole-flaps' stamp: 'lg 12/4/2007 11:11'!
hideFlaps
	self submorphs do: [ :m | m class = FlapTab ifTrue: [m hide]].! !

!PasteUpMorph methodsFor: '*ole-override' stamp: 'lg 12/23/2007 21:37'!
installFlaps
	"Get flaps installed within the bounds of the receiver"

	| localFlapTabs |
	Project current assureFlapIntegrity.
	self addGlobalFlaps.
	localFlapTabs := self localFlapTabs.
	localFlapTabs do: [:each | each visible: false].

	Preferences eToyFriendly ifTrue: [
		ProgressInitiationException display: 'Building Viewers...' translated
			during: [:bar |
				localFlapTabs keysAndValuesDo: [:i :each |
					each adaptToWorld.
					each setVisibilityByMode.
					self displayWorld.
					bar value: i / self localFlapTabs size]].
	] ifFalse: [
		localFlapTabs keysAndValuesDo: [:i :each |
			each adaptToWorld.
			each setVisibilityByMode.
			self displayWorld]].

	OLE updateSugarToolbar.
	self assureFlapTabsFitOnScreen.
	self bringTopmostsToFront! !

!PasteUpMorph methodsFor: '*OLE' stamp: 'ss 10/5/2007 16:28'!
makeAnimalButton:label
	^AnimalButton new label:label.
! !

!PasteUpMorph methodsFor: '*ole-game' stamp: 'lg 12/24/2007 09:58'!
setGameValue: n tallyObject: object
	self removeAllMorphs.
	n timesRepeat: [ self addMorph: object costume duplicate beSticky ].
	self spreadMorphs.! !

!PasteUpMorph methodsFor: '*ole-game' stamp: 'lg 11/1/2007 08:36'!
setGameValue: n
	| object |
	object := self submorphs first.
	self removeAllMorphs.
	n timesRepeat: [ self addMorph: object duplicate ].
	self spreadMorphs.! !

!PasteUpMorph methodsFor: '*OLE' stamp: 'ss 10/5/2007 15:32'!
showAnimalNames
	|row|
	row:= AlignmentMorph inARow:
			(self animalNames collect:[:label| self makeAnimalButton:label]).
	row openInWorld; position: 200@600
       ! !

!PasteUpMorph methodsFor: '*ole-project loading' stamp: 'lg 12/18/2007 07:48'!
showLinksToProjectsInDirectory: dirName 
	self removeAllMorphs.
	self layoutPolicy: TableLayout new; listDirection: #topToBottom; cellInset: 10; cellPositioning: #topLeft.
	self addLinksToProjectsInDirectory: dirName.
! !

!PasteUpMorph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 15:59'!
tallyObject
	^self valueOfProperty: #tallyObject! !

!PasteUpMorph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 15:59'!
tallyObject: object
	^self setProperty: #tallyObject toValue: object! !

PasteUpMorph subclass: #PicturePuzzleBlockMorph
	instanceVariableNames: 'interiorBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:43'!
hasRightPiece
	^self submorphs anySatisfy: [ :morph | (self valueOfProperty: #puzzlePosition) = (morph valueOfProperty: #puzzlePosition)].
 ! !

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:39'!
initialize
	super initialize.
	self color: World color.! !

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:24'!
isInteriorBlock
	^interiorBlock.! !

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:23'!
isInteriorBlock: flag 
	interiorBlock := flag.! !

PasteUpMorph subclass: #ProjectDirectoryMorph
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ProjectDirectoryMorph class methodsFor: 'projects' stamp: 'lg 12/20/2007 12:44'!
expungeChildProjects
	self shouldBeImplemented! !

!ProjectDirectoryMorph class methodsFor: 'updating' stamp: 'lg 12/18/2007 16:49'!
updateAllDirectoryListings
	WorldState addDeferredUIMessage: [Project removeAllButCurrent.].
	World allMorphsDo:
		[ :m | (m isKindOf: self) ifTrue: [m updateDirectoryListing] ].! !

!ProjectDirectoryMorph class methodsFor: 'projects' stamp: 'lg 12/20/2007 17:55'!
updateDirectoryListings
	World allMorphsDo: [ :m |
		(m isKindOf: self) ifTrue: [m updateDirectoryListing] ]! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'lg 12/20/2007 20:41'!
addLinksToProjectsInDirectory: dirName 
	| dir subdirNames |
	dir := FileDirectory on: (Smalltalk imagePath, FileDirectory slash, dirName).
	subdirNames := dir directoryNames collect: [ :sub | dir fullNameFor: sub ].
	subdirNames do: [ :subdir |
		(Project linksForDirectory: subdir) ifNotNilDo:
			[ :linksMorph | self addMorphBack: linksMorph ] ]! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'lg 12/18/2007 08:09'!
initialize
	super initialize.
	self layoutPolicy: TableLayout new; listDirection: #topToBottom; cellInset: 10; cellPositioning: #topLeft.! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'lg 12/20/2007 20:42'!
showDirectory: dirName
	directory := dirName.
	self removeAllMorphs.
	self addLinksToProjectsInDirectory: dirName.! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'lg 12/18/2007 14:07'!
updateDirectoryListing
	self showDirectory: directory.! !

PasteUpMorph subclass: #QuestionListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

PasteUpMorph subclass: #QuestionSetMorph
	instanceVariableNames: 'questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!QuestionSetMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 08:20'!
questions
	^(self submorphs collect: #duplicate) readStream.! !

PasteUpMorph subclass: #TallyMorph
	instanceVariableNames: 'tallyObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

TallyMorph subclass: #TallyAnswerMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:41'!
handlesMouseDown: event
	^true! !

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:38'!
isGameChoice
	^true! !

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:37'!
isGameInput
	^false! !

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:41'!
mouseDown: event
	NumberGame answer: self getGameValue.! !

!TallyMorph methodsFor: 'game' stamp: 'lg 10/14/2007 11:55'!
getGameValue
	^ (self submorphs select: [ :m | (m isKindOf: SimpleHighlightMorph) not]) size.
! !

!TallyMorph methodsFor: 'game' stamp: ''!
increment
	self setGameValue: self getGameValue + 1! !

!TallyMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 12:22'!
initialize
	super initialize.
! !

!TallyMorph methodsFor: 'game' stamp: ''!
isGameInput
	^ true! !

!TallyMorph methodsFor: 'game' stamp: 'lg 10/14/2007 11:58'!
removeAllObjects
	self submorphs do: [ :m | (m isKindOf: SimpleHighlightMorph) ifFalse: [self removeMorph: m]].! !

!TallyMorph methodsFor: 'game' stamp: 'lg 10/14/2007 12:02'!
setGameValue: n
	self removeAllObjects.
	n timesRepeat: [ self addMorph: tallyObject duplicate beSticky].
	self spreadMorphs.! !

!TallyMorph methodsFor: 'objects' stamp: 'lg 10/11/2007 11:29'!
setTallyObject: object
	tallyObject := object.! !

SymbolListType subclass: #GameInstrumentType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameInstrumentType methodsFor: 'initialization' stamp: 'lg 10/31/2007 16:00'!
initialize
	super initialize.
	self vocabularyName: #GameInstrumentType.
	symbols := #(none choice input).! !

!GameInstrumentType methodsFor: 'queries' stamp: 'lg 10/29/2007 14:06'!
representsAType
	^true.! !

ScriptableButton subclass: #AnimalButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!AnimalButton methodsFor: 'as yet unclassified' stamp: 'ss 10/5/2007 16:34'!
doButtonAction
	AnimalGame answer:self label! !

ScriptableButton subclass: #GameButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameButton methodsFor: 'game' stamp: 'lg 10/2/2007 15:37'!
doButtonAction
	NumberGame answer: (self submorphs first contents asInteger)! !

!GameButton methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 15:34'!
isGameChoice
	^true! !

!GameButton methodsFor: 'game' stamp: 'lg 10/2/2007 15:45'!
setGameValue: n 
	self submorphs first contents: n asString.
	self fixYourLayout.! !

SugarNavTab subclass: #OLESugarNavTab
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!SugarNavTab methodsFor: '*ole' stamp: 'lg 12/4/2007 11:38'!
setVisibilityByMode
	self visible: true! !

!FlapTab methodsFor: '*ole' stamp: 'lg 12/4/2007 11:36'!
setVisibilityByMode
	self visible: OLE isAuthorMode.! !

!False methodsFor: '*ole' stamp: 'lg 10/29/2007 12:35'!
yesNoString
	^'<no>'.! !

!TheWorldMenu methodsFor: '*ole' stamp: 'lg 11/24/2007 12:59'!
buildWorldMenu
	"Build the menu that is put up when the screen-desktop is clicked on"

	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu commandKeyHandler: self.
	self colorForDebugging: menu.
	menu addStayUpItem.
	self fillIn: menu from: {
		{'OLE...' translated. { self . #oleDo }. 'open the Open Learning Exchange extensions menu' }.
		nil.
		{'previous project' translated. { #myWorld . #goBack }. 'return to the most-recently-visited project' translated}.
		{'jump to project...' translated. { #myWorld . #jumpToProject }. 'put up a list of all projects, letting me choose one to go to' translated}.
		{'save project on file...' translated. { #myWorld  . #saveOnFile }. 'save this project on a file' translated}.
		{'load project from file...' translated. { self  . #loadProject }. 'load a project from a file' translated}.
		nil}.
	myWorld addUndoItemsTo: menu.

		self fillIn: menu from: {
		{'restore display (r)' . { World . #restoreMorphicDisplay }. 'repaint the screen -- useful for removing unwanted display artifacts, lingering cursors, etc.' translated}.
		nil}.
	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: { 
			{'open...' translated. { self  . #openWindow } }.
			{'windows...' translated. { self  . #windowsDo } }.
			{'changes...' translated. { self  . #changesDo } }}].
	self fillIn: menu from: { 
		{'help...' translated. { self  . #helpDo }.  'puts up a menu of useful items for updating the system, determining what version you are running, and much else' translated}.
		{'appearance...' translated. { self  . #appearanceDo }. 'put up a menu offering many controls over appearance.' translated}}.

	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: {
			{'do...' translated. { Utilities . #offerCommonRequests} . 'put up an editible list of convenient expressions, and evaluate the one selected.' translated}}].

	self fillIn: menu from: { 
		nil.
		{'objects (o)' translated. { #myWorld . #activateObjectsTool } . 'A tool for finding and obtaining many kinds of objects' translated}.
		{'new morph...' translated. { self  . #newMorph }. 'Offers a variety of ways to create new objects' translated}.
		nil.
		{'authoring tools...' translated. { self  . #scriptingDo } . 'A menu of choices useful for authoring' translated}.
		{'playfield options...' translated. { self  . #playfieldDo } . 'A menu of options pertaining to this object as viewed as a playfield' translated}.
		{'flaps...' translated. { self . #flapsDo } . 'A menu relating to use of flaps.  For best results, use "keep this menu up"' translated}.
		{'projects...' translated. { self  . #projectDo }. 'A menu of commands relating to use of projects' translated}}.
	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: { 
			{'print PS to file...' translated. { self  . #printWorldOnFile } . 'write the world into a postscript file' translated}.
			{'debug...' translated. { self  . #debugDo } . 'a menu of debugging items' translated}}].
	self fillIn: menu from: { 
		nil.
		{'save' translated. { SmalltalkImage current  . #saveSession } . 'save the current version of the image on disk' translated}.
		{'save as...' translated. { SmalltalkImage current . #saveAs }. 'save the current version of the image on disk under a new name.' translated}.
		{'save as new version' translated. { SmalltalkImage current . #saveAsNewVersion }. 'give the current image a new version-stamped name and save it under that name on disk.' translated}.
		{'save and quit' translated. { self  . #saveAndQuit } . 'save the current image on disk, and quit out of Squeak.' translated}.
		{'quit' translated. { self  . #quitSession } . 'quit out of Squeak.' translated}}.

	^ menu! !

!TheWorldMenu methodsFor: '*ole' stamp: 'lg 11/24/2007 12:22'!
oleDo
	self doPopUp: self oleMenu.! !

!TheWorldMenu methodsFor: '*ole' stamp: 'lg 12/18/2007 12:16'!
oleMenu
	| menu |
	menu := self menu: 'Open Learning Exchange'.
	^ self fillIn: menu from: {
		{ 'author mode' translated. { OLE. #authorMode } }.
		{ 'user mode' translated. { OLE. #userMode } }.
		nil.
		{ 'toggle flaps' translated. { self. #toggleFlaps } }.
		nil.
		{ 'deploy' translated. { OLE. #deploy } }
	}
! !

!TheWorldMenu methodsFor: '*ole' stamp: 'lg 11/24/2007 13:13'!
toggleFlaps
	| wasHidden |
	wasHidden := World submorphs noneSatisfy: [ :m | m class = FlapTab and: [ m visible ] ].
	World submorphs do: [  :m | m class = FlapTab ifTrue: [ m visible: wasHidden]].! !

!Number methodsFor: '*ole' stamp: 'lg 10/11/2007 12:02'!
roundedUp
	^self = self asInteger ifTrue: [self asInteger] ifFalse: [self asInteger + 1].! !

!Symbol methodsFor: '*ole' stamp: 'jwl 10/1/2007 17:40'!
value: x 
	^ x perform: self.
! !

!ProjectLoading class methodsFor: '*ole-public' stamp: 'lg 11/25/2007 11:10'!
findProjectFileNamed: projectName recursivelyInDirectory: directoryName
	| directory entries subdirs filename |
	directory := FileDirectory on: directoryName.
	entries := FileList2 projectOnlySelectionMethod: directory entries.
	entries := entries detect: [:each | (Project parseProjectFileName: each first) first = projectName] ifNone: [nil].
	entries isNil ifFalse: [^entries first].
	"Recurse"
	subdirs := directory directoryNames collect: [ :subdir | directory fullPathFor: subdir].
	subdirs do: [:dir | filename := self findProjectFileNamed: projectName recursivelyInDirectory: dir.
						 filename isNil ifFalse: [^(FileDirectory on: dir) fullPathFor: filename]].
	^nil.
! !

!ProjectLoading class methodsFor: '*ole-public' stamp: 'lg 12/17/2007 17:39'!
openFromDirectory: dir andProjectName: projectName
        | directory aStream entries fileName |
        (Project named: projectName)
                ifNotNilDo: [:project | ^ project enter].
        directory := FileDirectory on: dir.
        entries := FileList2 projectOnlySelectionMethod: directory entries.
        entries := entries
                                detect: [:each | (Project parseProjectFileName: each first) first = projectName] ifNone: [^ false].
        fileName := entries first.
        self
                showProgressBarDuring: [ProgressNotification signal: '0'.
                        directory := FileDirectory on: dir.
                        aStream := directory readOnlyFileNamed: fileName.
                        self
                                openName: fileName
                                stream: aStream
                                fromDirectory: directory
                                withProjectView: #none]
! !

!ProjectLoading class methodsFor: '*ole-loading' stamp: 'lg 12/7/2007 10:44'!
openRecursivelyFromDirectory: dirName andProjectName: projectName 
	| dir |
	dir := FileDirectory on: dirName.
	(self openFromDirectory: dirName andProjectName: projectName)
		ifTrue: [^true]
		ifFalse: [dir directoryNames do:
			[:subdir | (self openRecursivelyFromDirectory: (dir fullPathFor: subdir) andProjectName: projectName) ifTrue: [^true]]].
	^false.! !

EllipseMorph subclass: #EllipticGameInputMorph
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 06:38'!
getGameValue
	^label contents asInteger.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:27'!
handlesMouseDown: event
	^true! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 12:06'!
handlesMouseOver: event
	^true! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:30'!
initialize
	super initialize.
	label := StringMorph new.
	label  contents: '0'; center: self center.
	self addMorph: label.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:34'!
isGameChoice
	^true! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:33'!
layoutChanged
	label center: self center.
	^super layoutChanged.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 06:39'!
mouseDown: event
	NumberGame answer: self getGameValue.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 12:06'!
mouseEnter: event
	self color: (Color yellow alpha: 0.25).! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 12:06'!
mouseLeave: event
	self color: (Color transparent).! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:35'!
setGameValue: n
	label contents: n asString.! !

AlignmentMorph subclass: #DigitChooserMorph
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!DigitChooserMorph class methodsFor: 'as yet unclassified' stamp: 'lg 9/21/2007 14:07'!
additionsToViewerCategories
	^ #( (basic ((slot numericValue 'The most recently pressed digit (or zero, initially).' Number readWrite Player getNumericValue Player setNumericValue:))))! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:37'!
addButtonRows
	| row |
	#( (1 2 3) (4 5 6) (7 8 9) ) do:
		[ :digits |
			row := AlignmentMorph newRow vResizing: #spaceFill; cellInset: 3; yourself.
			digits do: [ :d | row addMorphBack: (self buttonFor: d)].
			self addMorph: row]! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 10/1/2007 16:45'!
buttonFor: digit 
	^ SimpleButtonMorph new target: NumberGame;
		label: digit asString font: Preferences standardEToysButtonFont;
		actionSelector: #answer:;
		arguments: { digit };
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:46'!
initialize
	super initialize.
	self extent: 300@300.
	self layoutPolicy: TableLayout new.
	self listDirection: #bottomToTop.
	self vResizing: #spaceFill.
	self cellInset: 3.
	self cellPositioning: #center.
	self listCentering: #justified.
	self wrapCentering: #justified.
	borderWidth := 2.
	self addButtonRows.
! !

SketchMorph subclass: #PicturePuzzlePieceMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzlePieceMorph methodsFor: 'puzzle' stamp: 'lg 10/10/2007 15:34'!
justDroppedInto: morph event: evt
	super justDroppedInto: morph event: evt.
	(morph isKindOf: PicturePuzzleBlockMorph) ifTrue:
		[ morph submorphs do: [ :m | morph owner placeInEmptyBox: m ] without: self ].
	self beep: 'click'.
	(morph owner isKindOf: PicturePuzzleMorph) ifTrue:
		[ morph owner checkCompletion ].! !

!PicturePuzzlePieceMorph methodsFor: 'puzzle' stamp: 'lg 10/14/2007 12:34'!
label: string 
	| morph font |
	font := string asInteger isNil ifTrue: [((TextStyle named: #BitstreamVeraSansMono) fontOfPointSize: 32)]
							  ifFalse: [((TextStyle named: #DevanagariNew) fontOfPointSize: 36)].
	morph := StringMorph contents: string font: font.
	morph shadowOffset: 2@2.
	morph center: self center.
	morph color: (Color white darker); hasDropShadow: true; shadowColor: (Color black alpha: 0.75).
	self addMorph: morph.! !

SketchMorph subclass: #RestartButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

SketchMorph subclass: #RippedOffMorph
	instanceVariableNames: 'target patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:21'!
justDroppedInto: morph event: evt
	super justDroppedInto: morph event: evt.
	morph == patch ifTrue: [self replacePatch: morph].! !

!RippedOffMorph methodsFor: '*ole' stamp: 'lg 9/25/2007 12:07'!
replacePatch: patchMorph
	target extent: patchMorph extent; position: patchMorph position.
	patch owner replaceSubmorph: patchMorph by: target.
	OLE congratulate.! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:22'!
setPatch: morph 
	patch := morph.
! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:26'!
setTarget: morph 
	target := morph.
	self form: target imageForm.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 09:26'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add custom menu items"

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'restore base graphic' translated target: self action: #restoreBaseGraphicFromMenu.
	aCustomMenu add: 'call this my base graphic' translated target: self action: #callThisBaseGraphic.
	aCustomMenu add: 'choose new graphic...' translated target: self action: #chooseNewGraphic.
	aCustomMenu addLine.
	aCustomMenu add: 'set as background' translated target: rotatedForm action: #setAsBackground.
	self addPaintingItemsTo: aCustomMenu hand: aHandMorph.
	self addPicturePuzzleItemsTo: aCustomMenu hand: aHandMorph.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 09:30'!
addPicturePuzzleItemsTo: aCustomMenu hand: aHandMorph
	aCustomMenu addLine.
	aCustomMenu add: 'create picture puzzle morph' translated
					target: self action: #grabPicturePuzzleMorph.
	aCustomMenu add: 'create picture puzzle thumbnail' translated
					target: self action: #grabPicturePuzzleThumbnailMorph.
! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 09:31'!
grabPicturePuzzleMorph
	| morph |
	morph := self picturePuzzleMorph openInWorld.
	morph center: World activeHand center.
	World activeHand grabMorph: morph.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 10:34'!
grabPicturePuzzleThumbnailMorph
	self picturePuzzleThumbnailMorph openInWorld grab.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/9/2007 20:20'!
picturePuzzleMorph
	^PicturePuzzleMorph new scrambleForm: self form! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 10:31'!
picturePuzzleThumbnailMorph
	^PicturePuzzleThumbnailMorph new makeThumbnailFromForm: self form.! !

ImageMorph subclass: #PicturePuzzleThumbnailMorph2
	instanceVariableNames: 'filename gridSize cache labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleThumbnailMorph2 class methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:28'!
file: filename cache: flag
	^PicturePuzzleThumbnailMorph2 new setImageFile: filename cache: flag.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:21'!
handlesMouseDown: event
	^true! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 11:05'!
initialize
	super initialize.
	gridSize := 4.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:08'!
loadFileIntoCache
	cache := (FileStream readOnlyFileNamed: filename) binary contents.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:10'!
loadForm
	^cache = nil ifTrue: [ImageReadWriter formFromFileNamed: filename] ifFalse: [ImageReadWriter formFromStream: cache readStream].! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:21'!
mouseDown: event
	self openPuzzle.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:31'!
openPuzzle
	| morph |
	World allMorphsDo: [ :m | (m isKindOf: PicturePuzzleMorph) ifTrue: [m delete] ].
	morph := PicturePuzzleMorph new rows: gridSize; columns: gridSize.
	morph labels: (labels caseOf: { [nil] -> [ #() ].
							      [#letters] -> ['ABCDEFGHIJKLMNOPQRSTUVWXYZ' asArray collect: #asString].
							      [#numbers] -> [(1 to: 100) collect: #asString]}).
	morph scrambleForm: self loadForm.
	morph center: World center.
	morph top: 90.
	morph openInWorld! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:14'!
setImageFile: aFilename cache: flag
	cache := nil.
	filename := aFilename.
	flag ifTrue: [self loadFileIntoCache].
	self showThumbnail.
! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:14'!
setImageFile: aFilename
	self setImageFile: aFilename cache: false.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 11:00'!
showThumbnail
	self image: (self loadForm scaledToSize: 200@150).
! !

!SugarNavigatorBar methodsFor: '*ole-override' stamp: 'lg 12/20/2007 21:50'!
makeTheButtons

	^ Preferences useArtificialSweetenerBar
		ifTrue: [self makeTheSimpleButtonsSqueakland]
		ifFalse: [OLE isAuthorMode ifTrue: [self makeTheSimpleButtons] ifFalse: [self makeTheMinimalButtons]]
! !

!SugarNavigatorBar methodsFor: '*ole-override' stamp: 'lg 12/23/2007 20:45'!
makeTheMinimalButtons
	"Add the buttons for use in normal kids' mode."

	^((Project current parent isTopProject) ifTrue: [{}] ifFalse: [{self buttonPrev}]),
	(((DisplayScreen actualScreenSize = OLPCVirtualScreen virtualScreenExtent)
		ifFalse: [{#spacer. self buttonZoom}]
		ifTrue: [#()])),
	{	#spacer.
		self buttonStop.
		}
! !

SimpleButtonMorph subclass: #ScramblerMorph
	instanceVariableNames: 'gridSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ScramblerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 17:49'!
doButtonAction
	World allMorphsDo: [ :m | (m isKindOf: PicturePuzzleMorph) ifTrue:
								[ m rows: gridSize; columns: gridSize; rescramble ] ].! !

!ScramblerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 17:45'!
drawOn: canvas
	| c p r blockWidth blockHeight |
	blockWidth := self width // gridSize.
	blockHeight := self height // gridSize.
	(0 to: gridSize-1) do: [ :row | (0 to: gridSize-1) do: [ :col |
		c := row+col \\ 2 = 0 ifTrue: [color] ifFalse: [Color white].
		p := self position + ((blockWidth*col) @ (blockHeight*row)).
		r := p corner: p + (blockWidth@blockHeight).
		canvas fillRectangle: r color: c
	]]! !

!ScramblerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 17:45'!
initialize
	super initialize.
	self color: Color black.
	gridSize := 3.! !

!Integer methodsFor: '*ole-sound' stamp: 'lg 10/4/2007 12:24'!
sayInNepali
	self beep: 'ne-' , self asWords.! !

!ProjectViewMorph methodsFor: '*ole' stamp: 'lg 10/13/2007 12:49'!
balloonText
	^nil.
! !

!ProjectViewMorph methodsFor: '*ole' stamp: 'lg 12/7/2007 11:18'!
setupDiskProxyUnderImage
	(project isKindOf: Project) ifTrue: [project := project setupDiskProxyUnderImage]! !
OLE initialize!
